Improve on 'approxidate'
[git/dscho.git] / git-stash.sh
blob03e589f764ba0570559fdb23a9a11cc2a0f24044
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--keep-index] [-q|--quiet] [<message>]]
11 or: $dashless clear"
13 SUBDIRECTORY_OK=Yes
14 OPTIONS_SPEC=
15 . git-sh-setup
16 require_work_tree
17 cd_to_toplevel
19 TMP="$GIT_DIR/.git-stash.$$"
20 trap 'rm -f "$TMP-*"' 0
22 ref_stash=refs/stash
24 no_changes () {
25 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
26 git diff-files --quiet --ignore-submodules
29 clear_stash () {
30 if test $# != 0
31 then
32 die "git stash clear with parameters is unimplemented"
34 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
35 then
36 git update-ref -d $ref_stash $current
40 create_stash () {
41 stash_msg="$1"
43 git update-index -q --refresh
44 if no_changes
45 then
46 exit 0
49 # state of the base commit
50 if b_commit=$(git rev-parse --verify HEAD)
51 then
52 head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
53 else
54 die "You do not have the initial commit yet"
57 if branch=$(git symbolic-ref -q HEAD)
58 then
59 branch=${branch#refs/heads/}
60 else
61 branch='(no branch)'
63 msg=$(printf '%s: %s' "$branch" "$head")
65 # state of the index
66 i_tree=$(git write-tree) &&
67 i_commit=$(printf 'index on %s\n' "$msg" |
68 git commit-tree $i_tree -p $b_commit) ||
69 die "Cannot save the current index state"
71 # state of the working tree
72 w_tree=$( (
73 rm -f "$TMP-index" &&
74 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
75 GIT_INDEX_FILE="$TMP-index" &&
76 export GIT_INDEX_FILE &&
77 git read-tree -m $i_tree &&
78 git add -u &&
79 git write-tree &&
80 rm -f "$TMP-index"
81 ) ) ||
82 die "Cannot save the current worktree state"
84 # create the stash
85 if test -z "$stash_msg"
86 then
87 stash_msg=$(printf 'WIP on %s' "$msg")
88 else
89 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
91 w_commit=$(printf '%s\n' "$stash_msg" |
92 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
93 die "Cannot record working tree state"
96 save_stash () {
97 keep_index=
98 while test $# != 0
100 case "$1" in
101 --keep-index)
102 keep_index=t
104 -q|--quiet)
105 GIT_QUIET=t
108 break
110 esac
111 shift
112 done
114 stash_msg="$*"
116 git update-index -q --refresh
117 if no_changes
118 then
119 say 'No local changes to save'
120 exit 0
122 test -f "$GIT_DIR/logs/$ref_stash" ||
123 clear_stash || die "Cannot initialize stash"
125 create_stash "$stash_msg"
127 # Make sure the reflog for stash is kept.
128 : >>"$GIT_DIR/logs/$ref_stash"
130 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
131 die "Cannot save the current status"
132 say Saved working directory and index state "$stash_msg"
134 git reset --hard ${GIT_QUIET:+-q}
136 if test -n "$keep_index" && test -n $i_tree
137 then
138 git read-tree --reset -u $i_tree
142 have_stash () {
143 git rev-parse --verify $ref_stash >/dev/null 2>&1
146 list_stash () {
147 have_stash || return 0
148 git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
149 sed -n -e 's/^[.0-9a-f]* refs\///p'
152 show_stash () {
153 flags=$(git rev-parse --no-revs --flags "$@")
154 if test -z "$flags"
155 then
156 flags=--stat
159 w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
160 b_commit=$(git rev-parse --verify "$w_commit^") &&
161 git diff $flags $b_commit $w_commit
164 apply_stash () {
165 git update-index -q --refresh &&
166 git diff-files --quiet --ignore-submodules ||
167 die 'Cannot apply to a dirty working tree, please stage your changes'
169 unstash_index=
171 while test $# != 0
173 case "$1" in
174 --index)
175 unstash_index=t
177 -q|--quiet)
178 GIT_QUIET=t
181 break
183 esac
184 shift
185 done
187 # current index state
188 c_tree=$(git write-tree) ||
189 die 'Cannot apply a stash in the middle of a merge'
191 # stash records the work tree, and is a merge between the
192 # base commit (first parent) and the index tree (second parent).
193 s=$(git rev-parse --verify --default $ref_stash "$@") &&
194 w_tree=$(git rev-parse --verify "$s:") &&
195 b_tree=$(git rev-parse --verify "$s^1:") &&
196 i_tree=$(git rev-parse --verify "$s^2:") ||
197 die "$*: no valid stashed state found"
199 unstashed_index_tree=
200 if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
201 test "$c_tree" != "$i_tree"
202 then
203 git diff-tree --binary $s^2^..$s^2 | git apply --cached
204 test $? -ne 0 &&
205 die 'Conflicts in index. Try without --index.'
206 unstashed_index_tree=$(git write-tree) ||
207 die 'Could not save index tree'
208 git reset
211 eval "
212 GITHEAD_$w_tree='Stashed changes' &&
213 GITHEAD_$c_tree='Updated upstream' &&
214 GITHEAD_$b_tree='Version stash was based on' &&
215 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
218 if test -n "$GIT_QUIET"
219 then
220 export GIT_MERGE_VERBOSITY=0
222 if git merge-recursive $b_tree -- $c_tree $w_tree
223 then
224 # No conflict
225 if test -n "$unstashed_index_tree"
226 then
227 git read-tree "$unstashed_index_tree"
228 else
229 a="$TMP-added" &&
230 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
231 git read-tree --reset $c_tree &&
232 git update-index --add --stdin <"$a" ||
233 die "Cannot unstage modified files"
234 rm -f "$a"
236 squelch=
237 if test -n "$GIT_QUIET"
238 then
239 squelch='>/dev/null 2>&1'
241 eval "git status $squelch" || :
242 else
243 # Merge conflict; keep the exit status from merge-recursive
244 status=$?
245 if test -n "$unstash_index"
246 then
247 echo >&2 'Index was not unstashed.'
249 exit $status
253 drop_stash () {
254 have_stash || die 'No stash entries to drop'
256 while test $# != 0
258 case "$1" in
259 -q|--quiet)
260 GIT_QUIET=t
263 break
265 esac
266 shift
267 done
269 if test $# = 0
270 then
271 set x "$ref_stash@{0}"
272 shift
274 # Verify supplied argument looks like a stash entry
275 s=$(git rev-parse --verify "$@") &&
276 git rev-parse --verify "$s:" > /dev/null 2>&1 &&
277 git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
278 git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
279 die "$*: not a valid stashed state"
281 git reflog delete --updateref --rewrite "$@" &&
282 say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
284 # clear_stash if we just dropped the last stash entry
285 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
288 apply_to_branch () {
289 have_stash || die 'Nothing to apply'
291 test -n "$1" || die 'No branch name specified'
292 branch=$1
294 if test -z "$2"
295 then
296 set x "$ref_stash@{0}"
298 stash=$2
300 git checkout -b $branch $stash^ &&
301 apply_stash --index $stash &&
302 drop_stash $stash
305 # Main command set
306 case "$1" in
307 list)
308 shift
309 if test $# = 0
310 then
311 set x -n 10
312 shift
314 list_stash "$@"
316 show)
317 shift
318 show_stash "$@"
320 save)
321 shift
322 save_stash "$@"
324 apply)
325 shift
326 apply_stash "$@"
328 clear)
329 shift
330 clear_stash "$@"
332 create)
333 if test $# -gt 0 && test "$1" = create
334 then
335 shift
337 create_stash "$*" && echo "$w_commit"
339 drop)
340 shift
341 drop_stash "$@"
343 pop)
344 shift
345 if apply_stash "$@"
346 then
347 test -z "$unstash_index" || shift
348 drop_stash "$@"
351 branch)
352 shift
353 apply_to_branch "$@"
356 if test $# -eq 0
357 then
358 save_stash &&
359 say '(To restore them type "git stash apply")'
360 else
361 usage
364 esac